org.gradle.tooling

## Interface LongRunningOperation

- All Known Subinterfaces:
    BuildLauncher, ModelBuilder<T>

      public interface LongRunningOperation

  Offers ways to communicate both ways with a Gradle operation, be it building a model or running tasks.

  Enables tracking progress via listeners that will receive events from the Gradle operation.

  Allows providing standard output streams that will receive output if the Gradle operation writes to standard streams.

  Allows providing standard input that can be consumed by the gradle operation (useful for interactive builds).

  Enables configuring the build run / model request with options like the Java home or jvm arguments. Those settings might not be supported by the target Gradle version. Refer to Javadoc for those methods to understand what kind of exception throw and when is it thrown.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `LongRunningOperation` | `addProgressListener(ProgressListener listener)` Adds a progress listener which will receive progress events as the operation runs.
    `LongRunningOperation` | `setJavaHome(File javaHome)` If the target Gradle version supports it you can use this setting to specify the Java home directory to use for the long running operation.
    `LongRunningOperation` | `setJvmArguments(String... jvmArguments)` If the target Gradle version supports it you can use this setting to specify the Java vm arguments to use for the long running operation.
    `LongRunningOperation` | `setStandardError(OutputStream outputStream)` Sets the `OutputStream` which should receive standard error logging generated while running the operation.
    `LongRunningOperation` | `setStandardInput(InputStream inputStream)` If the target Gradle version supports it you can use this setting to set the standard `InputStream` that will be used by builds.
    `LongRunningOperation` | `setStandardOutput(OutputStream outputStream)` Sets the `OutputStream` which should receive standard output logging generated while running the operation.
    `LongRunningOperation` | `withArguments(String... arguments)` Specify the command line build arguments.

- - ### Method Detail

    - #### setStandardOutput

          LongRunningOperation setStandardOutput(OutputStream outputStream)

      Sets the `OutputStream` which should receive standard output logging generated while running the operation. The default is to discard the output.
      Parameters:
        `outputStream` - The output stream.
      Returns:
        this

    - #### setStandardError

          LongRunningOperation setStandardError(OutputStream outputStream)

      Sets the `OutputStream` which should receive standard error logging generated while running the operation. The default is to discard the output.
      Parameters:
        `outputStream` - The output stream.
      Returns:
        this

    - #### setStandardInput

          LongRunningOperation setStandardInput(InputStream inputStream)

      If the target Gradle version supports it you can use this setting to set the standard `InputStream` that will be used by builds. Useful when the tooling api drives interactive builds.

      If the target Gradle version does not support it the long running operation will fail eagerly with `UnsupportedOperationConfigurationException` when the operation is started.

      If not configured or null passed the dummy input stream with zero bytes is used to avoid the build hanging problems.

      Parameters:
        `inputStream` - The input stream
      Returns:
        this
      Since:
        1.0-milestone-8

    - #### setJavaHome

          LongRunningOperation setJavaHome(File javaHome)
                                           throws IllegalArgumentException

      If the target Gradle version supports it you can use this setting to specify the Java home directory to use for the long running operation.

      If the target Gradle version does not support it the long running operation will fail eagerly with `UnsupportedOperationConfigurationException` when the operation is started.

      `BuildEnvironment` model contains information such as Java or Gradle environment. If you want to get hold of this information you can ask tooling API to build this model.

      If not configured or null passed the sensible default will be used.

      Parameters:
        `javaHome` - to use for the Gradle process
      Returns:
        this
      Throws:
        `IllegalArgumentException` - when supplied javaHome is not a valid folder.
      Since:
        1.0-milestone-8

    - #### setJvmArguments

          LongRunningOperation setJvmArguments(String... jvmArguments)

      If the target Gradle version supports it you can use this setting to specify the Java vm arguments to use for the long running operation.

      If the target Gradle version does not support it the long running operation will fail eagerly with `UnsupportedOperationConfigurationException` when the operation is started.

      `BuildEnvironment` model contains information such as Java or Gradle environment. If you want to get hold of this information you can ask tooling API to build this model.

      If not configured, null an empty array passed then the reasonable default will be used.

      Parameters:
        `jvmArguments` - to use for the Gradle process
      Returns:
        this
      Since:
        1.0-milestone-9

    - #### withArguments

          LongRunningOperation withArguments(String... arguments)

      Specify the command line build arguments. Useful mostly for running tasks via `BuildLauncher`.

      Be aware that not all of the Gradle command line options are supported! Only the build arguments that configure the build execution are supported. They are modelled in the Gradle API via `StartParameter`. Examples of supported build arguments: '--info', '-u', '-p'. The command line instructions that are actually separate commands (like '-?', '-v') are not supported. Some other instructions like '--daemon' are also not supported - the tooling API always runs with the daemon.

      If you specify unknown or unsupported command line option the `UnsupportedBuildArgumentException` will be thrown but only at the time when you execute the operation, i.e. `BuildLauncher.run()` or `ModelBuilder.get()`.

      For the list of all Gradle command line options please refer to the user guide or take a look at the output of the 'gradle -?' command. Supported arguments are those modelled by `StartParameter`.

      The arguments can potentially override some other settings you have configured. For example, the project directory or Gradle user home directory that are configured in the `GradleConnector`. Also, the task names configured by `BuildLauncher.forTasks(String...)` can be overridden if you happen to specify other tasks via the build arguments.

      See the example in the docs for `BuildLauncher`

      Parameters:
        `arguments` - Gradle command line arguments
      Returns:
        this
      Since:
        1.0-rc-1

    - #### addProgressListener

          LongRunningOperation addProgressListener(ProgressListener listener)

      Adds a progress listener which will receive progress events as the operation runs.
      Parameters:
        `listener` - The listener
      Returns:
        this